class WandouProxyAuthMiddleware:


    def __init__(self, settings):

        API = r'http://api.wandoudl.com/api/ip?app_key=*****&num=1&xy=1&type=1&lb=\r\n&nr=0&area_id=&'#填写API，num设置为1,格式为txt
        ip = requests.get(API).text
        self.proxy_url = 'http://{}'.format(ip)



    @classmethod
    def from_crawler(cls, crawler):
        s = cls(crawler.settings)
        return s


    def process_request(self, request, spider):
        request.meta["proxy"] = self.proxy_url


    def process_response(self, request, response, spider):

        return response


    def process_exception(self, request, exception, spider):
        spider.logger.error('url[%s] with error[%s]' % (request.url, exception))
